codeforces 716

A n个数 m  递增的 如果2个数的差大于m  那么前面的字就会消失 问最后有几个字

从后往前走一下

#include<stdio.h>
#include<algorithm>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<queue>
#include<map>
#include<iterator>
#include<stack>

using namespace std;

#define ll   __int64
#define MAXN  1010010
#define inf  2000000007
#define mod 1000000007

int z[MAXN];

int main()
{
    int n,k;
    scanf("%d%d",&n,&k);
    for(int i=1;i<=n;i++)
        scanf("%d",&z[i]);
    int cnt=1;
    for(int i=n-1;i>=1;i--)
    {
        if(z[i+1]-z[i]<=k)
            cnt++;
        else
            break;
    }
    printf("%d\n",cnt);
    return 0;
}

B 问子串中是否有26个正好是26个字母的

没有就-1   暴力

#include<stdio.h>
#include<algorithm>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<queue>
#include<map>
#include<iterator>
#include<stack>

using namespace std;

#define ll   __int64
#define MAXN  1010010
#define inf  2000000007
#define mod 1000000007

char z[MAXN];
int vis[27];

int main()
{
    scanf("%s",z);
    int len=strlen(z);
    int ok=0;
    for(int i=0;i<len-25;i++)
    {
        for(int j=0;j<27;j++)
            vis[j]=0;
        for(int j=i;j<i+26;j++)
        {
            if(z[j]!=‘?‘)
             vis[z[j]-‘A‘]++;
        }
        int ok1=0;
        int cnt=0;
        for(int j=0;j<26;j++)
        {
             if(vis[j]>1)
                ok1=1;
        }
       // printf("%d ",ok1);
        if(ok1==1)
            continue;
        for(int j=i;j<i+26;j++)
        {
            if(z[j]==‘?‘)
            {
                int k;
                for(k=0;k<26;k++)
                    if(vis[k]==0)
                        break;
                z[j]=‘A‘+k;
                vis[k]=1;
            }
            ok=1;
        }
        if(ok==1)
            break;
    }
    if(ok==1)
    {
        for(int i=0;i<len;i++)
            if(z[i]==‘?‘)
                z[i]=‘A‘;
    }
        if(ok==1)
            printf("%s",z);
        else
            printf("-1\n");
    return 0;
}

C 构造序列

很烂

最后   p*n + q*n =  k *k*(n+1)*(n+1)

k  可以是n   然后一直推上去     难受

#include<stdio.h>
#include<algorithm>
#include<stdlib.h>
#include<cstring>
#include<iostream>
#include<string>
#include<cmath>
#include<vector>
#include<queue>
#include<map>
#include<iterator>
#include<stack>

using namespace std;

#define ll   __int64
#define MAXN  1010010
#define inf  2000000007
#define mod 1000000007

ll z[MAXN],ans[MAXN];

int main()
{
    ll n;
    scanf("%I64d",&n);
    ans[1]=2;
    for(ll i=2;i<=n;i++)
        ans[i]=i*(i+1)*(i+1)-(i-1);
    for(int i=1;i<=n;i++)
        printf("%I64d\n",ans[i]);

    return 0;
}

时间: 2024-10-23 02:01:49

codeforces 716的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ